import { Observable } from 'rxjs';
export declare class BbApiConfig {
    baseUrl: string;
    paging?: {
        request?: Partial<BbApiPageRequestFormat>;
        response?: Partial<BbApiPageResponseFormat>;
    };
}
export interface BbApiPageParameters {
    pageNumber: number;
    pageSize: number;
    query: string | null;
    queryFields: string[];
    sort: {
        name: string;
        direction: 'asc' | 'desc';
    }[];
    extra: {}[];
}
export interface BbApiPageResponse<T = any> {
    totalPages: number;
    totalEntries: number;
    pageSize: number;
    pageNumber: number;
    data: T[];
}
export interface BbApiPageRequestFormat {
    pageNumber: string;
    pageSize: string;
    sort: string;
    sortDirection: string;
    query: string;
    queryFields: string;
}
export interface BbApiPageResponseFormat {
    totalPages: string;
    totalEntries: string;
    pageSize: string;
    pageNumber: string;
    data: string;
}
export declare class BbDataSourceRequest {
    private _request$;
    readonly when: Observable<BbApiPageParameters>;
    update(params?: Partial<BbApiPageParameters>): void;
}
export declare abstract class BbApiDataSource<T = any> {
    abstract handle(request: BbDataSourceRequest): Observable<BbApiPageResponse<T>>;
}
