import { BbAuthConfig } from './auth.interfaces';
import { BbStorage } from '../core/services/storage.service';
import { BbJwt } from '../core/services/jwt.service';
import { BbApi } from '../api/api.service';
export declare class BbAuth {
    private _jwt;
    private _storage;
    private _api;
    private _config;
    private readonly _apiUserStorageKey;
    private readonly _apiTokenStorageKey;
    private readonly _apiRefreshTokenStorageKey;
    private _user$;
    constructor(_jwt: BbJwt, _storage: BbStorage, _api: BbApi, _config: BbAuthConfig);
    readonly isAuthenticated: boolean;
    readonly user: import("rxjs").Observable<{
        [key: string]: any;
    }>;
    readonly accessToken: any;
    readonly refreshToken: any;
    readonly payload: any;
    login(email: string, password: string, as?: string[]): Promise<object>;
    logout(): void;
    refresh(): import("rxjs").Observable<string>;
    requestPassword(email: string): Promise<any>;
    resetPassword(token: string, newPassword: string): Promise<any>;
    setTokens(token: string, refreshToken: string): void;
    setUser(user: object): void;
    clear(): void;
    private mapToLogin;
    private mapToRefresh;
    private getEndpoint;
}
